-- by Frvetz
-- Contact: SlipDestroysFields@web.de
-- Date 09.05.2022


--[[


TUTORIAL


##English##

-Step-To-Step Guide for adjusting the values-

	- 1. Unzip the Mod

	- 2. Open the file "registerSlipDestroysFields.lua"

	- 3. Look for the lines 	'registerSlipDestroysFields.Strength = 1.8		-- Option "Little Destruction" '		at the end of the script (lines 225-229)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '

	- 4. 
		1. Change the number "1.8" in line 225      (registerSlipDestroysFields.Strength = 1.8   -- Option "Little Destruction") to change the destruction amount for the selected option "Little Destruction".

		2.  Change the number "1.65" in line 227      (registerSlipDestroysFields.Strength = 1.65   -- Option "Medium Destruction") to change the destruction amount for the selected option "Medium Destruction".

		3.  Change the number "1.8" in line 229      (registerSlipDestroysFields.Strength = 1.8   -- Option "Much Destruction") to change the destruction amount for the selected option "Much Destruction".


		!The numbers are very sensitive and do not need to be changed much to notice a change. Even a change of 0.1 has a remarkable impact!

	- 5. Save the edited file
	
	- 6. Zip the mod
	
	- 7. Insert the now zipped mod into your mod folder
	
	- 8. Delete the unzipped version of the mod


##Deutsch##

-Schritt-für-Schritt-Anleitung zum Anpassen der Werte-

	- 1. Entpacken sie den Mod
	
	- 2. Öffnen Sie die Datei "registerSlipDestroysFields.lua"

	- 3. Suchen Sie die Zeilen 	'registerSlipDestroysFields.Strength = 1.8 		-- Option "Little Destruction" ' 	am Ende des Skripts (Zeilen 225-229)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '
	
	- 4. 
		1. Ändern Sie die Zahl "1.8" in Zeile 225 (registerSlipDestroysFields.Strength = 1.8 -- Option "Little Destruction"), um die Zerstörungsstärke für die gewählte Option "Geringe Zerstörung" zu ändern.

		2.  Ändern Sie die Zahl "1.65" in Zeile 227 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction"), um den Zerstörungsgrad für die gewählte Option "Mittlere Zerstörung" zu ändern.

		3.  Ändern Sie die Zahl "1.8" in Zeile 229 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction"), um den Zerstörungsgrad für die gewählte Option "Viel Zerstörung" zu ändern.


		!Die Zahlen sind sehr empfindlich und müssen nicht viel geändert werden, um eine Änderung zu bemerken. Selbst eine Änderung von 0,1 hat eine bemerkenswerte Auswirkung!

	- 5. Speichern Sie die bearbeitete Datei
	
	- 6. Packen Sie den Mod
	
	- 7. Fügen Sie den nun gepackten Mod in Ihren Modordner ein
	
	- 8. Löschen Sie die ungepackte Version des Mods


##Français##

-Guide étape par étape pour ajuster les valeurs-

	- 1. Dézipper le Mod

	- 2. Ouvrir le fichier "registerSlipDestroysFields.lua"

	- Recherchez les lignes 	'registerSlipDestroysFields.Strength = 1.8 	-- Option "Little Destruction"'			 à la fin du script (lignes 225-229)
								'registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 	-- Option "Much Destruction" '

	- 4. 
		1. Modifiez le nombre "1,8" à la ligne 225 (registerSlipDestroysFields.Strength = 1,8 -- Option "Little Destruction") pour modifier la quantité de destruction pour l'option sélectionnée "Petite de destruction"

		2.  Changez le nombre "1.65" dans la ligne 227 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction") pour changer le montant de destruction pour l'option sélectionnée "Moyen de destruction"

		3.  Changez le nombre "1.8" dans la ligne 229 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction") pour changer le montant de destruction pour l'option sélectionnée "Beaucoup de destruction"


		! Les chiffres sont très sensibles et il n'est pas nécessaire de les modifier beaucoup pour remarquer un changement. Même un changement de 0,1 a un impact remarquable !

	- 5. Enregistrez le fichier modifié
	
	- 6. Zippez le mod
	
	- 7. Insérez le mod maintenant zippé dans votre dossier de mods
	
	- 8. Supprimez la version non compressée du module
--]]

source(g_currentModDirectory.."events/SettingsChangeEvent.lua")
source(g_currentModDirectory.."events/loadSettingsForClientEvent.lua")

SlipDestroysFields = {};
SlipDestroysFields.l10nEnv = "FS22_SlipDestroysFields";

function SlipDestroysFields.prerequisitesPresent(specializations)
	return true;
end;

function SlipDestroysFields.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", SlipDestroysFields);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", SlipDestroysFields);
	SpecializationUtil.registerEventListener(vehicleType, "onReadStream", SlipDestroysFields);
	SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", SlipDestroysFields);
	SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", SlipDestroysFields);
	SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", SlipDestroysFields);
end;

function SlipDestroysFields:onReadStream(streamId, connection)
    if connection.isServer then
        local spec = self.spec_wheels
        for i=1, #spec.wheels do
            local wheel = spec.wheels[i]
            if wheel.isSynchronized then
                wheel.destructionActive = streamReadBool(streamId)
            end
        end
    end
end

function SlipDestroysFields:onWriteStream(streamId, connection)
    if not connection.isServer then
        local spec = self.spec_wheels
        for i=1, #spec.wheels do
            local wheel = spec.wheels[i]
            if wheel.isSynchronized then
                streamWriteBool(streamId, wheel.destructionActive)
            end
        end
    end
end

function SlipDestroysFields:onReadUpdateStream(streamId, timestamp, connection)
    if connection.isServer then
        local hasUpdate = streamReadBool(streamId)
        if hasUpdate then
            local spec = self.spec_wheels

            for i=1, #spec.wheels do
                local wheel = spec.wheels[i]
                if wheel.isSynchronized then
                    wheel.destructionActive = streamReadBool(streamId)
                end
            end
        end
    end
end

function SlipDestroysFields:onWriteUpdateStream(streamId, connection, dirtyMask)
    if not connection.isServer then
        local spec = self.spec_wheels

        if streamWriteBool(streamId, bitAND(dirtyMask, spec.dirtyFlag) ~= 0) then
            for i=1, #spec.wheels do
                local wheel = spec.wheels[i]
                if wheel.isSynchronized then
                    streamWriteBool(streamId, wheel.destructionActive)
                end
            end
        end
    end
end

function SlipDestroysFields:onLoad(savegame)
	local spec = self.spec_SlipDestroysFields
	
	spec.maxSlip = 0
	
	for i=1, #self.spec_wheels.wheels do
		local wheel = self.spec_wheels.wheels[i]
		wheel.destructionActive = false
		wheel.raiseDirtyFlags = false
	end
	
	spec.dirtyFlag = self:getNextDirtyFlag()
end

function SlipDestroysFields.loadedMission(mission, node)
    if mission:getIsServer() then
        if mission.missionInfo.savegameDirectory ~= nil and fileExists(mission.missionInfo.savegameDirectory .. "/SlipDestroysFields.xml") then
            local xmlFile = XMLFile.load("SlipDestroysFields", mission.missionInfo.savegameDirectory .. "/SlipDestroysFields.xml")
            if xmlFile ~= nil then
				registerSlipDestroysFields.StrengthState = xmlFile:getFloat("SlipDestroysFields.StrengthState", registerSlipDestroysFields.StrengthState)
				registerSlipDestroysFields.Strength = xmlFile:getFloat("SlipDestroysFields.Strength", registerSlipDestroysFields.Strength)
				registerSlipDestroysFields.DebugState = xmlFile:getFloat("SlipDestroysFields.DebugState", registerSlipDestroysFields.DebugState)
				
                xmlFile:delete()
            end
        end
    end
    if mission.cancelLoading then
        return
    end
end

function SlipDestroysFields.loadSettingsForClient()
    g_client:getServerConnection():sendEvent(loadSettingsForClientEvent.new(registerSlipDestroysFields.Strength, registerSlipDestroysFields.StrengthState, registerSlipDestroysFields.DebugState))
end

function SlipDestroysFields.SettingsChangedClient(Strength, StrengthState, DebugState)
	registerSlipDestroysFields.Strength = Strength
	registerSlipDestroysFields.StrengthState = StrengthState
	registerSlipDestroysFields.DebugState = DebugState
end

function SlipDestroysFields.saveToXMLFile(missionInfo)
	if missionInfo.isValid then
        local xmlFile = XMLFile.create("SlipDestroysFields", missionInfo.savegameDirectory .. "/SlipDestroysFields.xml", "SlipDestroysFields")
        if xmlFile ~= nil then
			xmlFile:setFloat("SlipDestroysFields.StrengthState", registerSlipDestroysFields.StrengthState)
			xmlFile:setFloat("SlipDestroysFields.Strength", registerSlipDestroysFields.Strength)
			xmlFile:setFloat("SlipDestroysFields.DebugState", registerSlipDestroysFields.DebugState)
            xmlFile:save()
            xmlFile:delete()
        end
    end
end

function SlipDestroysFields:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if self:getIsOnField() then
		if self.isServer then
			local spec = self.spec_SlipDestroysFields
			
			----------------------------------------------------------------------------------------
			-- calculate the speed of the vehicle
			----------------------------------------------------------------------------------------
			local refSpeed = math.max( self.lastSpeed * 1000, 0.544 )
			spec.maxSlip = registerSlipDestroysFields.Strength			-- minimum percentage of slip for destruction
			
			----------------------------------------------------------------------------------------
			-- steering angle
			----------------------------------------------------------------------------------------
			if     self.rotatedTime < -1E-9 then 
				spec.maxSlip = spec.maxSlip + 0.4 * self.rotatedTime / self.minRotTime
			elseif self.rotatedTime >  1E-9 then 
				spec.maxSlip = spec.maxSlip + 0.4 * self.rotatedTime / self.maxRotTime
			end 
			spec.maxSlip = spec.maxSlip * refSpeed

			for wheelIndex,_ in pairs(self.spec_wheels.wheels) do
				local wheel = self.spec_wheels.wheels[wheelIndex]
				
				----------------------------------------------------------------------------------------
				-- calculate wheel speed + a minimum number for the wheel speed
				----------------------------------------------------------------------------------------
				if wheel.contact == Wheels.WHEEL_NO_CONTACT or wheel.AvgWheelSpeed == nil then
					wheel.AvgWheelSpeed = math.abs(refSpeed)
				else
					sw = getWheelShapeAxleSpeed(wheel.node, wheel.wheelShape) * wheel.radius
					wheel.AvgWheelSpeed = math.abs(0.5 * (wheel.AvgWheelSpeed + sw))
					sw = math.min(sw, wheel.AvgWheelSpeed)
					
					----------------------------------------------------------------------------------------
					-- check if wheel speed is higher than the vehicle speed (slip)
					----------------------------------------------------------------------------------------
					if  wheel.AvgWheelSpeed >= 1.8 then
						if sw >= 0.544 and  wheel.AvgWheelSpeed >  spec.maxSlip then
						
							----------------------------------------------------------------------------------------
							-- calculate wheel size
							----------------------------------------------------------------------------------------
							local width = 0.3 * wheel.width
							local length = math.min(0.3, 0.3 * wheel.width)
							local x, _, z = localToLocal(wheel.driveNode, wheel.repr, 0, 0, 0)
							local x0, y0, z0 = localToWorld(wheel.repr, x + width, 0, z - length)
							local x1, y1, z1 = localToWorld(wheel.repr, x - width, 0, z - length)
							local x2, y2, z2 = localToWorld(wheel.repr, x + width, 0, z + length)
							
							----------------------------------------------------------------------------------------
							-- create destruction under wheel
							----------------------------------------------------------------------------------------
							FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
							
							----------------------------------------------------------------------------------------
							-- calculate additional wheel size if configured
							----------------------------------------------------------------------------------------
							if wheel.additionalWheels ~= nil then
								for _, additionalWheel in pairs(wheel.additionalWheels) do
									local width = 0.3 * additionalWheel.width
									local length = math.min(0.3, 0.3 * additionalWheel.width)
									local refNode = wheel.node

									if wheel.repr ~= wheel.driveNode then
										refNode = wheel.repr
									end

									local xShift, yShift, zShift = localToLocal(additionalWheel.wheelTire, refNode, 0, 0, 0)
									local x0, y0, z0 = localToWorld(refNode, xShift + width, yShift, zShift - length)
									local x1, y1, z1 = localToWorld(refNode, xShift - width, yShift, zShift - length)
									local x2, y2, z2 = localToWorld(refNode, xShift + width, yShift, zShift + length)
									
									----------------------------------------------------------------------------------------
									-- create destruction under additional wheel
									----------------------------------------------------------------------------------------
									FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
								end
							end
							
							if wheel.raiseDirtyFlags ~= true then
								wheel.destructionActive = true
								self:raiseDirtyFlags(spec.dirtyFlag)
								wheel.raiseDirtyFlags = true
							end
						else
							if wheel.raiseDirtyFlags == true then
								wheel.destructionActive = false
								self:raiseDirtyFlags(spec.dirtyFlag)
								wheel.raiseDirtyFlags = false
							end
						end
					else
						if wheel.raiseDirtyFlags == true then
							wheel.destructionActive = false
							self:raiseDirtyFlags(spec.dirtyFlag)
							wheel.raiseDirtyFlags = false
						end
					end
				end
			end
		end
		
		if g_client ~= nil then
			for i=1, #self.spec_wheels.wheels do
				local wheel = self.spec_wheels.wheels[i]
				if wheel.destructionActive then
					
					----------------------------------------------------------------------------------------
					-- DEBUG
					----------------------------------------------------------------------------------------
					if registerSlipDestroysFields.DebugState == 1 and isActiveForInputIgnoreSelection then
						g_currentMission:showBlinkingWarning(g_i18n:getText("warning_Destruction", SlipDestroysFields.l10nEnv), 1000)
					end
					
					----------------------------------------------------------------------------------------
					-- PARTICLE SYSTEM: create particles/dust behind wheel when ground gets destroyed
					----------------------------------------------------------------------------------------
					if wheel.driveGroundParticleSystems ~= nil then
						local states = wheel.driveGroundParticleStates
						local enableSoilPS = true

						states.wheel_dry  = not wheel.hasSnowContact and enableSoilPS
						states.wheel_wet  = not wheel.hasSnowContact and enableSoilPS and groundIsWet
						states.wheel_dust = not wheel.hasSnowContact and not groundIsWet
						states.wheel_snow =     wheel.hasSnowContact

						for psName, state in pairs(states) do
							local typedPs = wheel.driveGroundParticleSystems[psName]
							if typedPs ~= nil then
								for _, ps in ipairs(typedPs) do
									if state then
										if self.movingDirection < 0 then
											setRotation(ps.emitterShape, 0, math.pi+wheel.steeringAngle, 0)
										else
											setRotation(ps.emitterShape, 0, wheel.steeringAngle, 0)
										end
										
										local wx, wy, wz = worldToLocal(wheel.node, getWorldTranslation(wheel.driveNode))
										setTranslation(ps.emitterShape, wx + ps.offsets[1], wy + ps.offsets[2], wz + ps.offsets[3])
										setScale(ps.emitterShape, wheel.width, wheel.radius*2, wheel.radius*2)

										local scale
										if psName ~= "wheel_dust" then
											local wheelSpeed = MathUtil.rpmToMps(wheel.netInfo.xDriveSpeed / (2*math.pi) * 60, wheel.radius)
											local wheelSlip = math.pow(wheelSpeed/self.lastSpeedReal, 2.5)
											scale = self:getDriveGroundParticleSystemsScale(ps, wheelSpeed) * wheelSlip
										else
											scale = self:getDriveGroundParticleSystemsScale(ps, self.lastSpeedReal)
										end

										if ps.isTintable then
											-- interpolate between different ground colors to avoid unrealisitic particle color changes
											if ps.lastColor == nil then
												ps.lastColor = {ps.wheel.lastColor[1],ps.wheel.lastColor[2],ps.wheel.lastColor[3]}
												ps.targetColor = {ps.wheel.lastColor[1],ps.wheel.lastColor[2],ps.wheel.lastColor[3]}
												ps.currentColor = {ps.wheel.lastColor[1],ps.wheel.lastColor[2],ps.wheel.lastColor[3]}
												ps.alpha = 1
											end

											if ps.alpha ~= 1 then
												ps.alpha = math.min(ps.alpha + dt/1000, 1)
												ps.currentColor = {MathUtil.vector3ArrayLerp(ps.lastColor, ps.targetColor, ps.alpha)}
												if ps.alpha == 1 then
													ps.lastColor[1] = ps.currentColor[1]
													ps.lastColor[2] = ps.currentColor[2]
													ps.lastColor[3] = ps.currentColor[3]
												end
											end

											if ps.alpha == 1 and ps.wheel.lastColor[1] ~= ps.targetColor[1] and ps.wheel.lastColor[2] ~= ps.targetColor[2] and ps.wheel.lastColor[3] ~= ps.targetColor[3] then
												ps.alpha = 0
												ps.targetColor[1] = ps.wheel.lastColor[1]
												ps.targetColor[2] = ps.wheel.lastColor[2]
												ps.targetColor[3] = ps.wheel.lastColor[3]
											end
										end

										if scale > 0 then
											ParticleUtil.setEmittingState(ps, true)
											if ps.isTintable then
												I3DUtil.setShaderParameterRec(ps.shape, "colorAlpha", ps.currentColor[1], ps.currentColor[2], ps.currentColor[3], 1, false)
											end
										else
											ParticleUtil.setEmittingState(ps, false)
										end

										if psName ~= "wheel_dust" then
											ParticleUtil.setEmitCountScale(ps, MathUtil.clamp(5*(wheel.AvgWheelSpeed - self.spec_SlipDestroysFields.maxSlip), 5, 8))
										else
											ParticleUtil.setEmitCountScale(ps, 0.5)
										end

										-- speeds
										local speedFactor = 1.0
										ParticleUtil.setParticleSystemSpeed(ps, ps.particleSpeed * speedFactor)
										ParticleUtil.setParticleSystemSpeedRandom(ps, ps.particleRandomSpeed * speedFactor)
									else
										ParticleUtil.setEmittingState(ps, false)
									end
								end
							end

							states[psName] = false
						end
					end
				
					----------------------------------------------------------------------------------------
					-- PARTICLE SYSTEM ADDITIONAL WHEELS: create particles/dust behind additional wheel when ground gets destroyed
					----------------------------------------------------------------------------------------
					if wheel.additionalWheels ~= nil then
						for _, additionalWheel in pairs(wheel.additionalWheels) do
							if additionalWheel.driveGroundParticleSystems ~= nil then
								local baseWheelWidth = MathUtil.mToInch(wheel.width)
								local dualWheelWidth = MathUtil.mToInch(additionalWheel.width)
								local wheelOffset = MathUtil.mToInch(additionalWheel.offset)
								
								if wheel.outerRimWidthAndDiam ~= nil then
									baseWheelWidth = wheel.outerRimWidthAndDiam[1]
								end
								if additionalWheel.outerRimWidthAndDiam ~= nil then
									dualWheelWidth = additionalWheel.outerRimWidthAndDiam[1]
								end
								
								local totalOffset = 0
								totalOffset = (additionalWheel.isLeft and 1 or -1) * MathUtil.inchToM(0.5*baseWheelWidth + wheelOffset + 0.5*dualWheelWidth )
								
								for name, particleSystems in pairs(additionalWheel.driveGroundParticleSystems) do
									for i=1, #particleSystems do
										local ps = particleSystems[i]
										ps.offsets[1] = totalOffset
										local wx, wy, wz = worldToLocal(wheel.node, getWorldTranslation(wheel.driveNode))
										setTranslation(ps.emitterShape, wx + ps.offsets[1], wy + ps.offsets[2], wz + ps.offsets[3])
										if table.getn(wheel.driveGroundParticleSystems[name]) < 3 then									-- not sure if this always works but it did on my tests so I kept it this way
											table.insert(wheel.driveGroundParticleSystems[name], ps)
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
end

if SlipDestroysFields.loaded == nil then
	SlipDestroysFields.loaded = true
	
	Mission00.loadMission00Finished = Utils.appendedFunction(Mission00.loadMission00Finished, SlipDestroysFields.loadedMission);
	FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, SlipDestroysFields.saveToXMLFile);
	
	FSBaseMission.onConnectionFinishedLoading = Utils.appendedFunction(FSBaseMission.onConnectionFinishedLoading, SlipDestroysFields.loadSettingsForClient)
end