-- Contact: SlipDestroysFields@web.de
-- Date 14.08.2022

SettingsChangeEvent = {}
local SettingsChangeEvent_mt = Class(SettingsChangeEvent, Event)
InitEventClass(SettingsChangeEvent, "SettingsChangeEvent")

function SettingsChangeEvent.emptyNew()
	local event = Event.new(SettingsChangeEvent_mt)
	


	return event
end

function SettingsChangeEvent.new(Strength, StrengthState, DebugState)
    local event = SettingsChangeEvent.emptyNew()
	    event.Strength = Strength
        event.StrengthState = StrengthState
        event.DebugState = DebugState
	return event
end

function SettingsChangeEvent:readStream(streamId, connection)
    self.Strength = streamReadFloat32(streamId)
    self.StrengthState = streamReadInt32(streamId)
    self.DebugState = streamReadInt32(streamId)
	
	self:run(connection)
end

function SettingsChangeEvent:writeStream(streamId, connection)
	streamWriteFloat32(streamId, self.Strength)
	streamWriteInt32(streamId, self.StrengthState)
	streamWriteInt32(streamId, self.DebugState)
end

function SettingsChangeEvent:run(connection)
	registerSlipDestroysFields.SettingsChanged(self.Strength, self.StrengthState, self.DebugState)
	if not connection:getIsServer() then
		g_server:broadcastEvent(SettingsChangeEvent.new(self.Strength, self.StrengthState, self.DebugState))
	end
end